#include "ftn.h"

typedef union tagBsyRequest
{
		char RawBuffer[10];
		struct
		{
			unsigned char SoftwareCode;
			unsigned char OpCode;
			FTNAddr FtnAddress;
		};


} BsyRequest, *lpBsyRequest;

DWORD WINAPI BusyPipesReadThread(LPVOID param)
{
	BsyRequest BR;
	unsigned short RetCode;
	DWORD cb;
	wchar_t LogStr[255];

	HANDLE hPipe = (HANDLE)param;
	ReadFile(hPipe, &(BR.RawBuffer), sizeof(BsyRequest), &cb, NULL);
	if (BR.OpCode == 3)
	{
		switch (BR.SoftwareCode)
		{
			case 1:wsprintfW(LogStr, L"Binkp session with %u:%u/%u.%u", BR.FtnAddress.zone, BR.FtnAddress.net, BR.FtnAddress.node, BR.FtnAddress.point);
				break;
			case 2:wsprintfW(LogStr, L"Tmail-IP session with %u:%u/%u.%u", BR.FtnAddress.zone, BR.FtnAddress.net, BR.FtnAddress.node, BR.FtnAddress.point);
				break;
			default: goto check;
		}
		
		AddLogEntry(LogStr);
		check:
		LogSessionAndSendNetmailToLink(&(BR.FtnAddress), BR.SoftwareCode);
		
	}

	WriteFile(hPipe, &RetCode, 2, &cb, NULL);
	DisconnectNamedPipe(hPipe);
	CloseHandle(hPipe);


	return 1;
}

DWORD WINAPI BusyPipesServerThread(LPVOID param)
{
	HANDLE hPipe,hThread;
	BOOL   fConnected = FALSE;
	unsigned int IdBusyPipesReadThread;
	AddLogEntry(L"Busy pipes thread started");

	begin:

	hPipe = CreateNamedPipeW( 
          L"\\\\.\\pipe\\FtnBsyPipe",
          PIPE_ACCESS_DUPLEX,       
          PIPE_TYPE_MESSAGE |       
          PIPE_READMODE_MESSAGE |   
          PIPE_WAIT,                
          PIPE_UNLIMITED_INSTANCES, 
          2,                  
          sizeof(BsyRequest), 
          0,                  
          NULL);              

		if (hPipe == INVALID_HANDLE_VALUE) 
		{
			printf("CreateNamedPipe failed, GLE=%d.\n", GetLastError()); 
			SetEvent(cfg.hExitEvent);
			return -1;
		}
		fConnected=ConnectNamedPipe(hPipe,NULL);
	    fConnected = ConnectNamedPipe(hPipe, NULL) ? 
         TRUE : (GetLastError() == ERROR_PIPE_CONNECTED); 

		if (fConnected)
		{
			hThread=(HANDLE)_beginthreadex(NULL,0,(unsigned int (__stdcall *)(void *))BusyPipesReadThread,(void *)hPipe,0,&IdBusyPipesReadThread);
			CloseHandle(hThread);
		}
		else
			CloseHandle(hPipe);

		goto begin;
}

