#include "ftn.h"

HANDLE hNetmailHeap;
NetmailMsgQueue NetmailQueue;

NETMAILROBOTPROC NetmailRobot[127];

void InitNetmailQueue()
{
	hNetmailHeap=HeapCreate(0,0,0);
	cfg.hNetmailHeap=hNetmailHeap;
	NetmailQueue.First=NULL;
	NetmailQueue.Last=NULL;
	NetmailQueue.hNewNetmailMsgEvent=CreateEventW(NULL,TRUE,FALSE,NULL);
	InitializeCriticalSection(&(NetmailQueue.CritSect));
}

lpNetmailMessage CreateNewNetmailMsg(FTNAddr Addr, HSTMT hstmt)
{
	lpNetmailMessage lpMsg;
	lpMsg=(NetmailMessage *)HeapAlloc(hNetmailHeap,HEAP_ZERO_MEMORY,sizeof(NetmailMessage));
	lpMsg->FromAddr.FullAddr=Addr.FullAddr;
	lpMsg->MsgId=(wchar_t *)HeapAlloc(hNetmailHeap,HEAP_ZERO_MEMORY,70);
	if (Addr.point==0)
		wsprintfW(lpMsg->MsgId,L"%u:%u/%u %08x",Addr.zone,Addr.net,Addr.node,GetMsgIdTime(hstmt));
	else
		wsprintfW(lpMsg->MsgId,L"%u:%u/%u.%u %08x",Addr.zone,Addr.net,Addr.node,Addr.point,GetMsgIdTime(hstmt));

	
	lpMsg->CreateTime=GetSQLTime();

	return lpMsg;

}


void PostReplyMsg(lpNetmailMessage lpMsg, HSTMT hstmt,wchar_t *FromName, wchar_t *Subj, wchar_t *MsgText,unsigned char isDirect, unsigned char isKillSent)
{
	lpNetmailMessage lpMsgNew;
	lpMsgNew=CreateNewNetmailMsg(lpMsg->ToAddr,hstmt);
	lpMsgNew->ToAddr.FullAddr=lpMsg->FromAddr.FullAddr;
	lpMsgNew->killsent=isKillSent;
	lpMsgNew->direct=isDirect;
	lpMsgNew->ReplyTo=(wchar_t *)HeapAlloc(hNetmailHeap,0,wcslen(lpMsg->MsgId)*2+2);
	lpMsgNew->FromName=(wchar_t *)HeapAlloc(hNetmailHeap,0,wcslen(FromName)*2+2);
	lpMsgNew->ToName=(wchar_t *)HeapAlloc(hNetmailHeap,0,wcslen(lpMsg->FromName)*2+2);
	lpMsgNew->Subject=(wchar_t *)HeapAlloc(hNetmailHeap,0,wcslen(Subj)*2+2);
	lpMsgNew->MsgText=(wchar_t *)HeapAlloc(hNetmailHeap,0,wcslen(MsgText)*2+2);
	lstrcpyW(lpMsgNew->ReplyTo,lpMsg->MsgId);
   	lstrcpyW(lpMsgNew->FromName,FromName);
	lstrcpyW(lpMsgNew->ToName,lpMsg->FromName);
	lstrcpyW(lpMsgNew->Subject,Subj);
	lstrcpyW(lpMsgNew->MsgText,MsgText);
	AddToNetmailQueue(lpMsgNew);
	
}




void AddToNetmailQueue(lpNetmailMessage NewMsg)
{
	EnterCriticalSection(&(NetmailQueue.CritSect));
	if (NetmailQueue.First==NULL)
	{
		NetmailQueue.First=NewMsg;
	}
	else
	{
		NetmailQueue.Last->NextMsg=NewMsg;
	}

	NetmailQueue.Last=NewMsg;
	LeaveCriticalSection(&(NetmailQueue.CritSect));
	SetEvent(NetmailQueue.hNewNetmailMsgEvent);
}

lpNetmailMessage GetNetmailFromQueue()
{
	lpNetmailMessage RetValue;
	
	EnterCriticalSection(&(NetmailQueue.CritSect));
	RetValue=NetmailQueue.First;
	if (RetValue==NULL) return NULL;

	NetmailQueue.First=RetValue->NextMsg;
	if (NetmailQueue.First==NULL) NetmailQueue.Last=NULL;
	LeaveCriticalSection(&(NetmailQueue.CritSect));
	return RetValue;

}


void NetmailFreeMem(lpNetmailMessage lpNetmailMsg)
{
	
	if (lpNetmailMsg->FromName!=NULL) HeapFree(hNetmailHeap,0,lpNetmailMsg->FromName);
	if (lpNetmailMsg->ToName!=NULL) HeapFree(hNetmailHeap,0,lpNetmailMsg->ToName);
	if (lpNetmailMsg->Subject!=NULL) HeapFree(hNetmailHeap,0,lpNetmailMsg->Subject);
	if (lpNetmailMsg->MsgText!=NULL) HeapFree(hNetmailHeap,0,lpNetmailMsg->MsgText);
	if (lpNetmailMsg->MsgId!=NULL) HeapFree(hNetmailHeap,0,lpNetmailMsg->MsgId);
	if (lpNetmailMsg->ReplyTo!=NULL) HeapFree(hNetmailHeap,0,lpNetmailMsg->ReplyTo);
	HeapFree(hNetmailHeap,0,lpNetmailMsg);
}


DWORD WINAPI NetmailTosserThread(LPVOID param)
{
SQLHDBC   hdbc;
SQLHSTMT  hstmt;
SQLRETURN sqlret;
SQLPOINTER pToken;

int WaitTime;
int WaitResult; 

SQLLEN cb0,cb1,cb2;

HANDLE WaitEvents[2];
lpNetmailMessage lpMsg;

unsigned char recv,killsent,pvt,fileattach,/*hold,*/arq,rrq,returnreq,direct,/*orphan,killfilesent,*/cfm,visible;
unsigned char isToMe;

unsigned int FromLinkId;
//unsigned int ToLinkId;
unsigned int MessageId;
unsigned int ActionCode;
unsigned int MsgStatus;

InterlockedIncrement(&(cfg.ThreadCount));

WaitEvents[0]=cfg.hExitEvent;
WaitEvents[1]=NetmailQueue.hNewNetmailMsgEvent;

WaitTime=INFINITE;
AddLogEntry(L"Netmail processing thread started");

WaitForNewMsg:

WaitResult=WaitForMultipleObjects(2,WaitEvents,FALSE,WaitTime);
if (WaitResult==WAIT_TIMEOUT)
{
	SQLFreeHandle(SQL_HANDLE_STMT,hstmt);
	SQLDisconnect(hdbc);
	SQLFreeHandle(SQL_HANDLE_DBC,hdbc);
	WaitTime=INFINITE;
	HeapCompact(hNetmailHeap,0);
	goto WaitForNewMsg;
}

if (WaitTime==INFINITE)
{
	SQLAllocHandle(SQL_HANDLE_DBC, cfg.henv, &hdbc); 
	sqlret=SQLDriverConnectW(hdbc, NULL, cfg.ConnectionString, SQL_NTS, NULL, 0, NULL, SQL_DRIVER_NOPROMPT);
	if (sqlret != SQL_SUCCESS && sqlret != SQL_SUCCESS_WITH_INFO)
	{
		
		SetEvent(cfg.hExitEvent);
		goto threadexit;
		//fatal error
	}
	SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
	WaitTime=5000;
}
switch(WaitResult)
{
	case WAIT_OBJECT_0: goto threadexit;
	case (WAIT_OBJECT_0+1): goto StartTossCycle;
}

StartTossCycle:
lpMsg=GetNetmailFromQueue();
if (lpMsg==NULL) goto CheckMoreMail;

recv=lpMsg->recv;
killsent=lpMsg->killsent;
pvt=lpMsg->pvt;
fileattach=lpMsg->fileattach;
//hold=lpMsg->hold;
arq=lpMsg->arq;
rrq=lpMsg->rrq;
returnreq=lpMsg->returnreq;
direct=lpMsg->direct;
//orphan=lpMsg->orphan;
//killfilesent=lpMsg->killfilesent;
cfm=lpMsg->cfm;


isToMe=0;//todo


if (recv)
{	
	MsgStatus=0;
	FromLinkId=0;
	ActionCode=0;

	SQLBindParameter(hstmt,1,SQL_PARAM_OUTPUT,SQL_C_ULONG,SQL_INTEGER,0,0,&MsgStatus,0,NULL);
	SQLBindParameter(hstmt,2,SQL_PARAM_INPUT,SQL_C_USHORT,SQL_SMALLINT,0,0,&(lpMsg->FromAddr.zone),0,NULL);
	SQLBindParameter(hstmt,3,SQL_PARAM_INPUT,SQL_C_USHORT,SQL_SMALLINT,0,0,&(lpMsg->FromAddr.net),0,NULL);
	SQLBindParameter(hstmt,4,SQL_PARAM_INPUT,SQL_C_USHORT,SQL_SMALLINT,0,0,&(lpMsg->FromAddr.node),0,NULL);
	SQLBindParameter(hstmt,5,SQL_PARAM_INPUT,SQL_C_USHORT,SQL_SMALLINT,0,0,&(lpMsg->FromAddr.point),0,NULL);
	SQLBindParameter(hstmt,6,SQL_PARAM_INPUT,SQL_C_USHORT,SQL_SMALLINT,0,0,&(lpMsg->ToAddr.zone),0,NULL);
	SQLBindParameter(hstmt,7,SQL_PARAM_INPUT,SQL_C_USHORT,SQL_SMALLINT,0,0,&(lpMsg->ToAddr.net),0,NULL);
	SQLBindParameter(hstmt,8,SQL_PARAM_INPUT,SQL_C_USHORT,SQL_SMALLINT,0,0,&(lpMsg->ToAddr.node),0,NULL);
	SQLBindParameter(hstmt,9,SQL_PARAM_INPUT,SQL_C_USHORT,SQL_SMALLINT,0,0,&(lpMsg->ToAddr.point),0,NULL);
	SQLBindParameter(hstmt,10,SQL_PARAM_INPUT,SQL_C_WCHAR,SQL_WVARCHAR,36,0,lpMsg->ToName,0,NULL);
	SQLBindParameter(hstmt,11,SQL_PARAM_INPUT,SQL_C_WCHAR,SQL_WVARCHAR,74,0,lpMsg->Subject,0,NULL);
	SQLBindParameter(hstmt,12,SQL_PARAM_INPUT_OUTPUT,SQL_C_ULONG,SQL_INTEGER,0,0,&FromLinkId,0,NULL);
	SQLBindParameter(hstmt,13,SQL_PARAM_INPUT_OUTPUT,SQL_C_ULONG,SQL_INTEGER,0,0,&ActionCode,0,NULL);
	sqlret=SQLExecDirectW(hstmt,L"{?=call sp_CheckNetmailMsg(?,?,?,?,?,?,?,?,?,?,?,?)}",SQL_NTS);
	SQLCloseCursor(hstmt);
	SQLFreeStmt(hstmt,SQL_RESET_PARAMS);

	
	switch(MsgStatus)
	{
		case 0:isToMe=0; visible=0;break;
		case 1:isToMe=1;visible=1;break;
		case 2://         
		case 3://   
			{
				isToMe=1;visible=1;
				if (NetmailRobot[ActionCode]!=NULL)
				{ 
					if(MsgStatus==2)
					{
						if((NetmailRobot[ActionCode])(lpMsg,FromLinkId,FALSE)) goto DelMsg;
					}
					else
					{
						if((NetmailRobot[ActionCode])(lpMsg,FromLinkId,TRUE)) goto DelMsg;
					}
				}
				break;
			}

		
	}
}
else if (killsent==0) visible=1;
lpMsg->CreateTime.fraction=0;
MessageId=0;
SQLBindParameter(hstmt,1,SQL_PARAM_OUTPUT,SQL_C_ULONG,SQL_INTEGER,0,0,&MessageId,0,NULL);
SQLBindParameter(hstmt,2,SQL_PARAM_INPUT,SQL_C_USHORT,SQL_SMALLINT,0,0,&(lpMsg->FromAddr.zone),0,NULL);
SQLBindParameter(hstmt,3,SQL_PARAM_INPUT,SQL_C_USHORT,SQL_SMALLINT,0,0,&(lpMsg->FromAddr.net),0,NULL);
SQLBindParameter(hstmt,4,SQL_PARAM_INPUT,SQL_C_USHORT,SQL_SMALLINT,0,0,&(lpMsg->FromAddr.node),0,NULL);
SQLBindParameter(hstmt,5,SQL_PARAM_INPUT,SQL_C_USHORT,SQL_SMALLINT,0,0,&(lpMsg->FromAddr.point),0,NULL);
SQLBindParameter(hstmt,6,SQL_PARAM_INPUT,SQL_C_USHORT,SQL_SMALLINT,0,0,&(lpMsg->ToAddr.zone),0,NULL);
SQLBindParameter(hstmt,7,SQL_PARAM_INPUT,SQL_C_USHORT,SQL_SMALLINT,0,0,&(lpMsg->ToAddr.net),0,NULL);
SQLBindParameter(hstmt,8,SQL_PARAM_INPUT,SQL_C_USHORT,SQL_SMALLINT,0,0,&(lpMsg->ToAddr.node),0,NULL);
SQLBindParameter(hstmt,9,SQL_PARAM_INPUT,SQL_C_USHORT,SQL_SMALLINT,0,0,&(lpMsg->ToAddr.point),0,NULL);
SQLBindParameter(hstmt,10,SQL_PARAM_INPUT,SQL_C_TYPE_TIMESTAMP,SQL_TYPE_TIMESTAMP,19,0,&(lpMsg->CreateTime),0,NULL);

SQLBindParameter(hstmt,11,SQL_PARAM_INPUT,SQL_C_WCHAR,SQL_WVARCHAR,36,0,lpMsg->FromName,0,NULL);
SQLBindParameter(hstmt,12,SQL_PARAM_INPUT,SQL_C_WCHAR,SQL_WVARCHAR,36,0,lpMsg->ToName,0,NULL);
SQLBindParameter(hstmt,13,SQL_PARAM_INPUT,SQL_C_WCHAR,SQL_WVARCHAR,74,0,lpMsg->Subject,0,NULL);
	
if (lpMsg->MsgId==NULL)
{
	SQLBindParameter(hstmt,14,SQL_PARAM_INPUT,SQL_C_WCHAR,SQL_WVARCHAR,127,0,NULL,0,&cb0);
	cb0=SQL_NULL_DATA;
}
else 	SQLBindParameter(hstmt,14,SQL_PARAM_INPUT,SQL_C_WCHAR,SQL_WVARCHAR,127,0,lpMsg->MsgId,0,NULL);

if (lpMsg->ReplyTo==NULL)
{
	SQLBindParameter(hstmt,15,SQL_PARAM_INPUT,SQL_C_WCHAR,SQL_WVARCHAR,127,0,NULL,0,&cb1);
	cb1=SQL_NULL_DATA;
}
else SQLBindParameter(hstmt,15,SQL_PARAM_INPUT,SQL_C_WCHAR,SQL_WVARCHAR,127,0,lpMsg->ReplyTo,0,NULL);

SQLBindParameter(hstmt,16,SQL_PARAM_INPUT,SQL_C_WCHAR,SQL_WLONGVARCHAR,wcslen(lpMsg->MsgText),0,(SQLPOINTER) 25,0,&cb2);
cb2=SQL_LEN_DATA_AT_EXEC((int)wcslen(lpMsg->MsgText)*2);

SQLBindParameter(hstmt,17,SQL_PARAM_INPUT,SQL_C_BIT,SQL_BIT,0,0,&killsent,0,NULL);
SQLBindParameter(hstmt,18,SQL_PARAM_INPUT,SQL_C_BIT,SQL_BIT,0,0,&pvt,0,NULL);
SQLBindParameter(hstmt,19,SQL_PARAM_INPUT,SQL_C_BIT,SQL_BIT,0,0,&fileattach,0,NULL);
SQLBindParameter(hstmt,20,SQL_PARAM_INPUT,SQL_C_BIT,SQL_BIT,0,0,&arq,0,NULL);
SQLBindParameter(hstmt,21,SQL_PARAM_INPUT,SQL_C_BIT,SQL_BIT,0,0,&rrq,0,NULL);
SQLBindParameter(hstmt,22,SQL_PARAM_INPUT,SQL_C_BIT,SQL_BIT,0,0,&returnreq,0,NULL);
SQLBindParameter(hstmt,23,SQL_PARAM_INPUT,SQL_C_BIT,SQL_BIT,0,0,&direct,0,NULL);
SQLBindParameter(hstmt,24,SQL_PARAM_INPUT,SQL_C_BIT,SQL_BIT,0,0,&cfm,0,NULL);
SQLBindParameter(hstmt,25,SQL_PARAM_INPUT,SQL_C_BIT,SQL_BIT,0,0,&visible,0,NULL);
SQLBindParameter(hstmt,26,SQL_PARAM_INPUT,SQL_C_BIT,SQL_BIT,0,0,&recv,0,NULL);
sqlret=SQLExecDirectW(hstmt,L"{?=call sp_Add_Netmail_Message(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)}",SQL_NTS);
if (sqlret==SQL_NEED_DATA)
{
	sqlret=SQLParamData(hstmt,&pToken);
	if (sqlret==SQL_NEED_DATA) SQLPutData(hstmt,lpMsg->MsgText,wcslen(lpMsg->MsgText)*2);
	sqlret=SQLParamData(hstmt,&pToken);
}


SQLFreeStmt(hstmt,SQL_RESET_PARAMS);


//todo

DelMsg:
NetmailFreeMem(lpMsg);
//

CheckMoreMail:
EnterCriticalSection(&(NetmailQueue.CritSect));
if (NetmailQueue.First==NULL)
{
	ResetEvent(NetmailQueue.hNewNetmailMsgEvent);
	SetEvent(cfg.hNetmailOutEvent);
}
LeaveCriticalSection(&(NetmailQueue.CritSect));
goto WaitForNewMsg;

threadexit: 


_InterlockedDecrement(&(cfg.ThreadCount));
SetEvent(cfg.hThreadEndEvent);

return 0;
}

